
;Small Window - DednDave, 4-2011

        .XCREF
        .NOLIST
        INCLUDE    \masm32\include\masm32rt.inc
        INCLUDE    SmallWin.inc
        .LIST

;###############################################################################################

        .DATA

szClassName     db 'SmallWindowClass',0
szAppName       db 'Small Window',0
szStbMessage    db 'X: xxxx Y: xxxx'
szNullString    db 0

;------------------------------

        .DATA?

        ALIGN   4

hInstance       dd ?
hWin            dd ?
hStatus         dd ?
StbHeight       dd ?
StbPos          dd ?
cwr             RECT <>

;###############################################################################################

        .CODE

        OPTION  PROLOGUE:None
        OPTION  EPILOGUE:None

        ALIGN   16

WndProc PROC    hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

;------------------------------

        mov     ecx,[esp+8]                             ;uMsg
        cmp     ecx,WM_MOUSEMOVE
        jz      ShwPos

        cmp     ecx,WM_SIZE
        jz      SizWin

        cmp     ecx,WM_LBUTTONDOWN
        jz      LimitC

        cmp     ecx,WM_LBUTTONUP
        jz      LimitX

;        cmp     ecx,WM_MOUSELEAVE
;        jz      MLeave

        cmp     ecx,WM_CREATE
        jz      Create

        cmp     ecx,WM_CLOSE
        jz      WndPrY

        cmp     ecx,WM_DESTROY
        jz      WndPrZ

;------------------------------

        JMP     DefWindowProc

;------------------------------

WndPr0: xor     eax,eax
        ret     16

;------------------------------

ShwPos: movzx   eax,word ptr [esp+16]                  ;EAX = X position (lParam low word)
        push    ebx
;        mov     pt.x,eax
        call    B2As4
        movzx   eax,word ptr [esp+22]                  ;EAX = Y position (lParam high word)
        mov dword ptr szStbMessage+3,ecx
;        mov     pt.y,eax
        call    B2As4
        mov dword ptr szStbMessage+11,ecx
        pop     ebx
        INVOKE  SendMessage,hStatus,SB_SETTEXT,0,offset szStbMessage
        jmp     WndPr0

;------------------------------

SizWin: mov     ecx,[esp+4]                            ;ECX = hWnd
        sub     esp,sizeof RECT
        INVOKE  GetClientRect,ecx,esp
        pop     eax
        pop     edx
        pop     ecx
;        sub     eax,ecx                                ;EAX = client height
        pop     ecx
;        sub     edx,ecx                                ;EDX = client width
        mov     ecx,StbHeight
        sub     eax,ecx
        mov     StbPos,eax
        INVOKE  MoveWindow,hStatus,0,eax,edx,ecx,TRUE
        jmp     WndPr0

;------------------------------

LimitC: push    ebx
        mov     ebx,[esp+8]                            ;EBX = hWnd
        INVOKE  GetClientRect,ebx,offset cwr
        INVOKE  ClientToScreen,ebx,offset cwr
        mov     eax,cwr.top
        mov     edx,cwr.left
        sub     eax,StbHeight
        add     cwr.right,edx
        add     cwr.bottom,eax
        INVOKE  ClipCursor,offset cwr
        pop     ebx
        jmp     WndPr0

;------------------------------

LimitX: INVOKE  ClipCursor,NULL
        jmp     WndPr0

;------------------------------

;MLeave: INVOKE  SendMessage,hStatus,SB_SETTEXT,0,offset szNullString
;        jmp     WndPr0

;------------------------------

Create: mov     ecx,[esp+4]                            ;ECX = hWnd
        INVOKE  CreateStatusWindow,WS_CHILD or WS_VISIBLE,offset szNullString,ecx,CID_STATUSBAR
        mov     hStatus,eax
        sub     esp,sizeof RECT
        INVOKE  GetWindowRect,eax,esp
        pop     eax
        pop     edx
        pop     ecx
        pop     eax
        sub     eax,edx
        mov     StbHeight,eax
        jmp     WndPr0

;------------------------------

;WM_CLOSE

WndPrY: INVOKE  DestroyWindow,[esp+4]                   ;hWnd
        jmp     WndPr0

;------------------------------

;WM_DESTROY

WndPrZ: INVOKE  PostQuitMessage,NULL
        jmp     WndPr0

;------------------------------

WndProc ENDP

        OPTION  PROLOGUE:PrologueDef
        OPTION  EPILOGUE:EpilogueDef

;***********************************************************************************************

B2As4   PROC

        mov     edx,4294968          ;2^32/1000
        mov     ebx,10               ;per digit
        mul     edx                  ;extend first digit
        mov     ecx,edx              ;digit 1 in CL
        mul     ebx                  ;second digit
        mov     ch,dl                ;digit 2 in CH
        mul     ebx                  ;third digit
        bswap   ecx                  ;digits 1 & 2 up high
        mov     ch,dl                ;digit 3 in CH
        mul     ebx                  ;digit 4 in DL
        lea     ecx,[edx+ecx+'0000'] ;combine and make ASCII
        bswap   ecx                  ;re-order bytes
        cmp     cl,30h
        jnz     B2As42

        cmp     ch,30h
        jnz     B2As41

        test    ecx,0F0000h
        jnz     B2As40

        and     ecx,03F202020h
        ret

B2As40: mov     cx,2020h
        ret

B2As41: mov     cl,20h

B2As42: ret

B2As4   ENDP

;***********************************************************************************************

_main   PROC

;------------------------------

;initialize common controls

        xor     edi,edi                                 ;EDI = 0
        push    edi
        push    sizeof INITCOMMONCONTROLSEX
        INVOKE  InitCommonControlsEx,esp

;------------------------------

;register the window class

        INVOKE  GetModuleHandle,edi
        mov     hInstance,eax
        xchg    eax,ebp                                 ;EBP = hInstance
        INVOKE  LoadIcon,ebp,IDI_ICON
        xchg    eax,ebx                                 ;EBX = hIcon
        INVOKE  LoadCursor,edi,IDC_ARROW                ;EAX = hCursor
        mov     esi,offset szClassName                  ;ESI = offset szClassName
        push    ebx                                     ;WNDCLASSEX.hIconSm
        push    esi                                     ;WNDCLASSEX.lpszClassName
        push    edi                                     ;WNDCLASSEX.lpszMenuName
        push    COLOR_SCROLLBAR+1                       ;WNDCLASSEX.hbrBackground
        push    eax                                     ;WNDCLASSEX.hCursor
        push    ebx                                     ;WNDCLASSEX.hIcon
        push    ebp                                     ;WNDCLASSEX.hInstance
        push    edi                                     ;WNDCLASSEX.cbWndExtra
        push    edi                                     ;WNDCLASSEX.cbClsExtra
        push    WndProc                                 ;WNDCLASSEX.lpfnWndProc
        push    edi                                     ;WNDCLASSEX.style
        push    sizeof WNDCLASSEX                       ;WNDCLASSEX.cbSize
        INVOKE  RegisterClassEx,esp

;------------------------------

;create the window

        INVOKE  CreateWindowEx,edi,esi,offset szAppName,
                WS_OVERLAPPEDWINDOW or WS_VISIBLE or WS_CLIPCHILDREN,
                CW_USEDEFAULT,SW_SHOWNORMAL,400,300,edi,edi,ebp,edi
        mov     hWin,eax
        INVOKE  UpdateWindow,eax

;------------------------------

;message loop

        mov     ebp,esp                                 ;EBP = offset MSG
        jmp short mLoop1

mLoop0: INVOKE  TranslateMessage,ebp
        INVOKE  DispatchMessage,ebp

mLoop1: INVOKE  GetMessage,ebp,edi,edi,edi
        inc     eax                                     ;exit only
        shr     eax,1                                   ;if 0 or -1
        jnz     mLoop0                                  ;otherwise, we loop

;------------------------------

;exit program

        pop     eax                                     ;MSG.wParam is the parm for ExitProcess
        JMP     ExitProcess

_main   ENDP

;###############################################################################################

        END     _main

